<?php

namespace Drupal\craftyclicks\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Plugin implementation of the 'craftyclicks_widget_type' widget.
 *
 * @FieldWidget(
 *   id = "craftyclicks_widget_type",
 *   label = @Translation("Craftyclicks widget type"),
 *   field_types = {
 *     "craftyclicks_field_type"
 *   }
 * )
 */
class CraftyclicksWidgetType extends WidgetBase {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element['value'] = $element + [
      '#type' => 'textfield',
      '#default_value' => isset($items[$delta]->value) ? $items[$delta]->value : NULL,
      '#size' => 'big',
      '#maxlength' => '255',
        '#attributes' => array(
          'class' => array(
            'craftyclicks',
          ),
        ),
    ];

    $element['postcode_lookup'] = [
        '#type' => 'button',
        '#value' => $this->t('Find'),
      ];

    return $element;
  }

}
